/* ==========================================================================

  StrConvert.c convert special ASCII name to special character.

*/
const char * Help_StrConvert[]={
"     /b  or  \\b  ==  Back-slash sign               -->   \\",
"     /s  or  \\s  ==  Slash sign                    -->   /",
"     /xFF  or  \\xFF  ==  Hex value                 -->   0xFF",
"     /d  or  \\d  ==  '\\n' (new line)               -->   .",
"     /n  or  \\n  ==  '\\n' (new line)               -->   .",
"     /a  or  \\a  ==  Line-break (0X0A)             -->   .",
" ",
"     *** use '/n'   as a source empty line.",
""
};
/*   ========================================================================== */

#define SPACE                  ' '
#define SLASH                  '/'
#define BACK_SLASH             '\\'

#include <stdio.h>

void StrConvert(char * s1, char * s2)
{
  char * p1;
  char * p2;
  int x, n;
  char Last;

  p1 = s1;
  p2 = s2;

  Last = 0;
  while (p2[0])
    {
      if ((p2[0] != SLASH) && (p2[0] != BACK_SLASH)) {
        p1[0] = p2[0];
	    Last = 0;
      } else
        {
		  Last = p2[0];
          p2++;
          switch (p2[0])
            {
              case 'b':
              case 'B':
              case BACK_SLASH:
                p1[0] = BACK_SLASH;
                break;
              case 'a':
              case 'A':
                p1[0] = 0x0A;
                break;
              case 's':
              case 'S':
              case SLASH:
                p1[0] = SLASH;
                break;
              case 'x':
              case 'X':
        				n=0;
        				sscanf(p2+1,"%2x%n",&x,&n);
        				if (n>0)
        				{
        					p2 += n;
        					p1[0] = (char)x;
        					break;
        				}
                p1[0] = ':';
                break;
              case 'd':
              case 'D':
              case 'n':
              case 'N':
                p1[0] = '\n';
                break;

              case 0x0:
              default:
				p1++[0] = Last;
				p1[0] = p2[0];
                /*  p1[0] = 0x0; */
                break;
            }
        }
      p1++;
	  p2++;
    } 
  
  p1[0] = 0x0;
  p1++;
  p1[0] = 0x0;
}

